#ifndef __vtkTestProperty_h
#define __vtkTestProperty_h
 
#include "vtkAlgorithm.h"
 
class vtkDataSet;
class vtkPolyData;

#include <iostream>
using std::cerr;
using std::endl;

class vtkTestProperty : public vtkAlgorithm
{
  public:
    static vtkTestProperty *New();
    //vtkTypeRevisionMacro(vtkTestProperty,vtkAlgorithm);
    vtkTypeMacro(vtkTestProperty,vtkAlgorithm);
    void PrintSelf(ostream& os, vtkIndent indent);
 
  // Description:
  // Get the output data object for a port on this algorithm.
    vtkPolyData* GetOutput();
    vtkPolyData* GetOutput(int);
    virtual void SetOutput(vtkDataObject* d);
 
  // Description:
  // see vtkAlgorithm for details
    virtual int ProcessRequest(vtkInformation*,
                               vtkInformationVector**,
                               vtkInformationVector*);
 
  protected:
    vtkTestProperty();
    ~vtkTestProperty();
 
  // Description:
  // This is called by the superclass.
  // This is the method you should override.
    virtual int RequestDataObject(
                                  vtkInformation* request,
                                  vtkInformationVector** inputVector,
                                  vtkInformationVector* outputVector );
 
  // convenience method
    virtual int RequestInformation(
                                   vtkInformation* request,
                                   vtkInformationVector** inputVector,
                                   vtkInformationVector* outputVector );
 
  // Description:
  // This is called by the superclass.
  // This is the method you should override.
    virtual int RequestData(
                            vtkInformation* request,
                            vtkInformationVector** inputVector,
                            vtkInformationVector* outputVector );
 
  // Description:
  // This is called by the superclass.
  // This is the method you should override.
    virtual int RequestUpdateExtent(
                                    vtkInformation*,
                                    vtkInformationVector**,
                                    vtkInformationVector* );
 
    virtual int FillOutputPortInformation( int port, vtkInformation* info );
    virtual int FillInputPortInformation( int port, vtkInformation* info );
 
  private:
    vtkTestProperty( const vtkTestProperty& ); // Not implemented.
    void operator = ( const vtkTestProperty& );  // Not implemented.

  private:
    int NPoints;
  public:
    vtkGetMacro(NPoints,int);
    vtkSetMacro(NPoints,int);
};
 
#endif
